/*************************************************  Channel Functions Header  **************************************************

	Red Rapids
	797 North Grove Rd
	Suite 101
	Richardson, TX 75081
	www.redrapids.com | support@redrapids.com

	Copyright 2018, Red Rapids, Inc.

*************************************************  Channel Functions Header  **************************************************/

#ifndef _CHANNEL_FUNCTIONS_H_
#define _CHANNEL_FUNCTIONS_H_

#if defined(__cplusplus)
	extern "C" {
#endif

// Structure to store the synchronizer configuration settings.
typedef struct
{
	unsigned StartEvent;
	unsigned StopEvent;
	unsigned SampleCount;
} s_Synchronizer;

// Structure to store the results returned by a channel status query to the device.
typedef struct
{
	unsigned DMAMarker;
	unsigned Error[2];
} s_ChannelStatus;

// Structure to store interrupt mask settings assigned to each type of channel event.
typedef struct
{
	unsigned DMAMarker;
	unsigned Error[2];
} s_ChannelIntMask;

// Prototypes for each of the channel functions.
void ChannelMask(s_Handle *p_HW, unsigned ChannelNumber, s_ChannelIntMask ChannelIntMask);
void ClearChannelStatus(s_Handle *p_HW, unsigned ChannelNumber);
void FlowControl(s_Handle *p_HW, unsigned ChannelNumber, unsigned OnOff);
int FlowStatus(s_Handle *p_HW, unsigned ChannelNumber);
int GetChannelStatus(s_Handle *p_HW, unsigned ChannelNumber, s_ChannelStatus *p_ChannelStatus);
void LoadSynchronizer(s_Handle *p_HW, unsigned ChannelNumber, s_Synchronizer Synchronizer);
int ReadyStatus(s_Handle *p_HW, unsigned ChannelNumber);

#ifdef __cplusplus
}
#endif

#endif
