/*************************************************  Utility Functions Header  **************************************************

	Red Rapids
	797 North Grove Rd
	Suite 101
	Richardson, TX 75081
	www.redrapids.com | support@redrapids.com

	Copyright 2018, Red Rapids, Inc.

*************************************************  Utility Functions Header  **************************************************/

#ifndef _UTILITY_FUNCTIONS_H_
#define _UTILITY_FUNCTIONS_H_

#if defined(__cplusplus)
	extern "C" {
#endif

// Prototypes for each of the utility functions.
void ClearLatency(s_Handle *p_HW);
int DataFile(char *p_File, unsigned PageSize, double FsDivisor, unsigned DataItemSize);
int DataLoad(char *p_File, void **p_Address, unsigned PageSize, unsigned NumPages, unsigned DataItemSize);
int DataSave(char *p_File, void **p_Address, unsigned PageSize, unsigned NumPages, unsigned DataItemSize);
int FreeResources(s_Handle *p_HW, unsigned ChannelCount, s_UIOScan UIO);
float InterruptResponse(s_Handle *p_HW);
void InterruptTimeout(s_Handle *p_HW, unsigned IntTimeout);
unsigned MemSize(s_Handle *p_HW);
int MemTest(s_Handle *p_HW, unsigned SRAMSelect);
void PciBenchmark(s_Handle *p_HW);
void PciPerformance(s_Handle *p_HW, float *p_Performance);
void ProcessChannels(s_Handle *p_HW);
void UserInit(s_Handle *p_HW, s_User *p_User);

#ifdef __cplusplus
}
#endif

#endif
